## mingw-w64-bcunit-5.3.101-1.src.tar.zst

=== CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2010-2021 Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

cmake_minimum_required(VERSION 3.22)

project(BCUnit VERSION "3.0.2" LANGUAGES C)

set(VERSION "${PROJECT_VERSION}")
set(RELEASE "${PROJECT_VERSION_PATCH}")


option(ENABLE_BCUNIT_AUTOMATED "Compile BCUnit automated interface" ON)
option(ENABLE_BCUNIT_BASIC "Compile BCUnit basic interface" ON)
option(ENABLE_BCUNIT_CONSOLE "Compile BCUnit console interface" ON)
option(ENABLE_BCUNIT_CURSES "Compile BCUnit curses interface" OFF)
option(ENABLE_BCUNIT_DOC "Install BCUnit documentation" OFF)
option(ENABLE_BCUNIT_EXAMPLES "Compile BCUnit example programs" OFF)
option(ENABLE_BCUNIT_TEST "Compile BCUnit internal test program" OFF)
option(ENABLE_BCUNIT_MEMTRACE "Enable BCUnit internal memory tracking" OFF)
option(ENABLE_BCUNIT_DEPRECATED "Enable use of deprecated v1.1 names" OFF)

set(CMAKE_REQUIRED_FLAGS "${CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE}}")
set(CMAKE_REQUIRED_LINK_OPTIONS "${CMAKE_EXE_LINKER_FLAGS_${CMAKE_BUILD_TYPE}}")

include(GNUInstallDirs)

configure_file(${PROJECT_SOURCE_DIR}/config.h.cmake ${PROJECT_BINARY_DIR}/config.h)


set(exec_prefix ${CMAKE_INSTALL_BINDIR})
set(libdir ${CMAKE_INSTALL_LIBDIR})
set(includedir ${CMAKE_INSTALL_INCLUDEDIR})
configure_file(${PROJECT_SOURCE_DIR}/bcunit.pc.in ${PROJECT_BINARY_DIR}/bcunit.pc)
install(FILES ${PROJECT_BINARY_DIR}/bcunit.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)


if(MSVC)
	add_compile_options(/wd4477)
else()
	add_compile_options(-Wall -W -pedantic -Wshadow -ansi -std=c99)
	# Do not show warnings when building this code
	add_compile_options(-Wno-clobbered -Wno-format -Wno-format-security -Wno-unused-parameter -Wno-unused-variable -Wno-pedantic)
endif()

if(ENABLE_BCUNIT_MEMTRACE)
	add_compile_definitions("MEMTRACE")
endif()
if(ENABLE_BCUNIT_DEPRECATED)
	add_compile_definitions("USE_DEPRECATED_BCUNIT_NAMES")
endif()
if(ENABLE_BCUNIT_CURSES)
	set(CURSES_NEED_NCURSES 1)
	find_package(Curses)
	if(NOT CURSES_FOUND)
		message("Disabling curses as it has not been found!")
		set(ENABLE_BCUNIT_CURSES 0)
	endif()
endif()

add_subdirectory(build)

include_directories(${PROJECT_BINARY_DIR})

add_subdirectory(BCUnit)
if(ENABLE_BCUNIT_DOC)
	add_subdirectory(Man)
endif()
add_subdirectory(Share)
if(ENABLE_BCUNIT_EXAMPLES)
	add_subdirectory(Examples)
endif()


include(CMakePackageConfigHelpers)
set(CMAKE_MODULES_INSTALL_DIR "${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/cmake")
configure_package_config_file("${PROJECT_NAME}Config.cmake.in" "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
	INSTALL_DESTINATION "${CMAKE_MODULES_INSTALL_DIR}"
	NO_SET_AND_CHECK_MACRO
)
write_basic_package_version_file("${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
	VERSION ${PROJECT_VERSION}
	COMPATIBILITY AnyNewerVersion
)
install(FILES
	"${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
	"${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
	DESTINATION ${CMAKE_MODULES_INSTALL_DIR}
)

export(EXPORT ${PROJECT_NAME}Targets
	FILE "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake"
)
install(EXPORT ${PROJECT_NAME}Targets
	FILE "${PROJECT_NAME}Targets.cmake"
	DESTINATION ${CMAKE_MODULES_INSTALL_DIR}
)

=== BCUnit/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

add_subdirectory(Sources)
add_subdirectory(Headers)

=== Examples/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

add_library(bcunitexamples STATIC ExampleTests.c)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

if(ENABLE_BCUNIT_BASIC)
	add_subdirectory(BasicTest)
endif()
if(ENABLE_BCUNIT_CONSOLE)
	add_subdirectory(ConsoleTest)
endif()
if(ENABLE_BCUNIT_CURSES)
	add_subdirectory(CursesTest)
endif()
if(ENABLE_BCUNIT_AUTOMATED)
	add_subdirectory(AutomatedTest)
endif()

=== Man/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

install(FILES man3/BCUnit.3
	DESTINATION share/man/man3
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
)

=== Share/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(SHARE_FILES
	BCUnit-List.dtd
	BCUnit-List.xsl
	BCUnit-Run.dtd
	BCUnit-Run.xsl
	Memory-Dump.dtd
	Memory-Dump.xsl
)

install(FILES ${SHARE_FILES}
	DESTINATION share/BCUnit
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
)

=== build/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2016  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

if(NOT CPACK_PACKAGE_NAME)
	string(TOLOWER "${PROJECT_NAME}" LOWERCASE_PROJECT_NAME)
	set(CPACK_PACKAGE_NAME "${LOWERCASE_PROJECT_NAME}")
endif()

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "BCUnit unit test framework forked from CUnit by Belledonne Communications projects")
set(CPACK_PACKAGE_VENDOR "Belledonne Communications")
set(CPACK_PACKAGE_CONTACT "jehan.monnier@linphone.org")

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../COPYING")

set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})

set(CPACK_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}-${PROJECT_VERSION})

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES
"${CMAKE_BINARY_DIR}"
"^${PROJECT_SOURCE_DIR}/.git*"
)

#set(CPACK_COMPONENTS_ALL runtime devel)
#set(CPACK_COMPONENT_DEVEL_DEPENDS runtime)
#set(CPACK_COMPONENT_RUNTIME_DISPLAY_NAME ${PACKAGE})
#set(CPACK_COMPONENT_DEVEL_DISPLAY_NAME ${PACKAGE}-devel)

find_package(Git 1.7.10) # --count option of git rev-list is available only since (more or less) git 1.7.10
if(GIT_EXECUTABLE)
	execute_process(
		COMMAND ${GIT_EXECUTABLE} rev-list --count ${PROJECT_VERSION}..HEAD
		OUTPUT_VARIABLE PROJECT_VERSION_BUILD
		OUTPUT_STRIP_TRAILING_WHITESPACE
		WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
	)
	# if BUILD VERSION is available, append it to package filename
	set (CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_FILE_NAME}-${PROJECT_VERSION_BUILD}")

	set(CPACK_RPM_PACKAGE_RELEASE "${PROJECT_VERSION_BUILD}")
	set(CPACK_DEBIAN_PACKAGE_VERSION "${PROJECT_VERSION}-${PROJECT_VERSION_BUILD}")
endif()

set(CPACK_RPM_COMPONENT_INSTALL OFF)
if("${CPACK_GENERATOR}" STREQUAL "RPM")
	set (CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig ${CMAKE_INSTALL_FULL_LIBDIR}/cmake)
endif()

if("${CPACK_GENERATOR}" STREQUAL "RPM" OR "${CPACK_GENERATOR}" STREQUAL "DEB")
	if (NOT CPACK_PACKAGING_INSTALL_PREFIX AND CMAKE_INSTALL_PREFIX)
		set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
		message(STATUS "Setting packaging install prefix to ${CPACK_PACKAGING_INSTALL_PREFIX}")
	endif()
endif()

if("${CPACK_GENERATOR}" STREQUAL "DEB")
	set(CPACK_DEBIAN_PACKAGE_DEBUG ON)
	set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
	set(CPACK_PROJECT_CONFIG_FILE "${CMAKE_BINARY_DIR}/CPackEnv.cmake")
	file(WRITE "${CPACK_PROJECT_CONFIG_FILE}" "set(ENV{LD_LIBRARY_PATH} \"./${CMAKE_INSTALL_FULL_LIBDIR}\")")
	set(SHLIBS_FILE     "${CMAKE_CURRENT_BINARY_DIR}/shlibs")
	file(WRITE "${SHLIBS_FILE}" "libbctoolbox  ${BCTOOLBOX_SO_VERSION} ${CPACK_PACKAGE_NAME}\n")
	file(APPEND "${SHLIBS_FILE}" "libbctoolbox-tester  ${BCTOOLBOXTESTER_SO_VERSION} ${CPACK_PACKAGE_NAME}\n")
	execute_process(COMMAND chmod 644 "${SHLIBS_FILE}")
	set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA ${SHLIBS_FILE})
endif()

include(CPack)

=== doc/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(DOC_FILES
	BCUnit_doc.css
	error_handling.html
	fdl.html
	index.html
	introduction.html
	managing_tests.html
	running_tests.html
	test_registry.html
	writing_tests.html
)

install(FILES ${DOC_FILES}
	DESTINATION share/doc/BCUnit
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
)


file(GLOB HEADER_FILES "../BCUnit/Headers/*.h")
list(APPEND HEADER_FILES "../BCUnit/Sources/Win/Win.h")

install(FILES ${HEADER_FILES}
	DESTINATION share/doc/BCUnit/headers
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
)

=== BCUnit/Headers/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(AUTOMATED_INCLUDES Automated.h)
set(BASIC_INCLUDES Basic.h)
set(CONSOLE_INCLUDES Console.h)
set(CURSES_INCLUDES CUCurses.h)
set(FRAMEWORK_INCLUDES CUError.h BCUnit_intl.h MyMem.h TestDB.h TestRun.h Util.h)

set(HEADER_FILES ${FRAMEWORK_INCLUDES})

if(ENABLE_BCUNIT_BASIC)
	list(APPEND HEADER_FILES ${BASIC_INCLUDES})
endif()

if(ENABLE_BCUNIT_CONSOLE)
	list(APPEND HEADER_FILES ${CONSOLE_INCLUDES})
endif()

if(ENABLE_BCUNIT_AUTOMATED)
	list(APPEND HEADER_FILES ${AUTOMATED_INCLUDES})
endif()

if(ENABLE_BCUNIT_CURSES)
	list(APPEND HEADER_FILES ${CURSES_INCLUDES})
endif()

configure_file(BCUnit.h.in BCUnit.h @ONLY)

install(FILES ${HEADER_FILES} ${CMAKE_CURRENT_BINARY_DIR}/BCUnit.h
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/BCUnit
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
)

=== BCUnit/Sources/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2010-2023 Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(BASIC_SOURCE_FILES Basic/Basic.c)
set(AUTOMATED_SOURCE_FILES Automated/Automated.c)
set(CONSOLE_SOURCE_FILES Console/Console.c)
set(CURSES_SOURCE_FILES Curses/Curses.c)
set(FRAMEWORK_SOURCE_FILES
	Framework/CUError.c
	Framework/MyMem.c
	Framework/TestDB.c
	Framework/TestRun.c
	Framework/Util.c
)
set(FRAMEWORK_SYMBOLS "
	CU_add_suite
	CU_add_suite_with_setup_and_teardown
	CU_add_test
	CU_assertImplementation
	CU_cleanup_registry
	CU_clear_previous_results
	CU_compare_strings
	CU_create_new_registry
	CU_destroy_existing_registry
	CU_get_all_test_complete_handler
	CU_get_current_suite
	CU_get_current_test
	CU_get_elapsed_time
	CU_get_error
	CU_get_error_action
	CU_get_error_msg
	CU_get_fail_on_inactive
	CU_get_failure_list
	CU_get_number_of_asserts
	CU_get_number_of_failure_records
	CU_get_number_of_failures
	CU_get_number_of_successes
	CU_get_number_of_suites_failed
	CU_get_number_of_suites_run
	CU_get_number_of_tests_failed
	CU_get_number_of_tests_run
	CU_get_registry
	CU_get_run_results_string
	CU_get_run_summary
	CU_get_suite
	CU_get_suite_at_pos
	CU_get_suite_by_index
	CU_get_suite_by_name
	CU_get_suite_cleanup_failure_handler
	CU_get_suite_complete_handler
	CU_get_suite_init_failure_handler
	CU_get_suite_pos
	CU_get_suite_pos_by_name
	CU_get_suite_start_handler
	CU_get_test
	CU_get_test_at_pos
	CU_get_test_by_index
	CU_get_test_by_name
	CU_get_test_complete_handler
	CU_get_test_pos
	CU_get_test_pos_by_name
	CU_get_test_start_handler
	CU_initialize_registry
	CU_registry_initialized
	CU_is_test_running
	CU_print_run_results
	CU_register_nsuites
	CU_register_suites
	CU_run_all_tests
	CU_run_suite
	CU_run_test
	CU_set_all_test_complete_handler
	CU_set_error
	CU_set_error_action
	CU_set_fail_on_inactive
	CU_set_registry
	CU_set_suite_active
	CU_set_suite_cleanup_failure_handler
	CU_set_suite_cleanupfunc
	CU_set_suite_complete_handler
	CU_set_suite_init_failure_handler
	CU_set_suite_initfunc
	CU_set_suite_name
	CU_set_suite_start_handler
	CU_set_test_active
	CU_set_test_complete_handler
	CU_set_test_func
	CU_set_test_name
	CU_set_test_start_handler
	CU_translate_special_characters
	CU_trim
	CU_trim_left
	CU_trim_right
")

set(SOURCE_FILES ${FRAMEWORK_SOURCE_FILES})
source_group(framework FILES ${FRAMEWORK_SOURCE_FILES})
if(ENABLE_BCUNIT_BASIC)
	list(APPEND SOURCE_FILES ${BASIC_SOURCE_FILES})
	source_group(basic FILES ${BASIC_SOURCE_FILES})
	set(BASIC_SYMBOLS "
	CU_basic_get_mode
	CU_basic_run_suite
	CU_basic_run_test
	CU_basic_run_tests
	CU_basic_set_mode
	CU_basic_show_failures
	CU_set_trace_handler
	")
endif()
if(ENABLE_BCUNIT_AUTOMATED)
	list(APPEND SOURCE_FILES ${AUTOMATED_SOURCE_FILES})
	source_group(automated FILES ${AUTOMATED_SOURCE_FILES})
	set(AUTOMATED_SYMBOLS "
	CU_automated_enable_junit_xml
	CU_automated_enable_partial_junit
	CU_automated_run_tests
	CU_list_tests_to_file
	CU_set_output_filename
	")
endif()
if(ENABLE_BCUNIT_CONSOLE)
	list(APPEND SOURCE_FILES ${CONSOLE_SOURCE_FILES})
	source_group(console FILES ${CONSOLE_SOURCE_FILES})
	set(CONSOLE_SYMBOLS "
	CU_console_run_tests
	")
endif()
if(ENABLE_BCUNIT_CURSES)
	list(APPEND SOURCE_FILES ${CURSES_SOURCE_FILES})
	source_group(curses FILES ${CURSES_SOURCE_FILES})
endif()
if(WIN32)
	configure_file(bcunit.def.in bcunit.def)
	list(APPEND SOURCE_FILES ${CMAKE_CURRENT_BINARY_DIR}/bcunit.def)
endif()


add_library(bcunit ${SOURCE_FILES})
target_include_directories(bcunit PUBLIC
	$<INSTALL_INTERFACE:include>
	$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/BCUnit/Headers>
	$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/BCUnit/Headers>
)
set_target_properties(bcunit PROPERTIES VERSION 1.0.1)

if(ANDROID)
	target_link_libraries(bcunit PUBLIC "log")
endif()
if(CURSES_LIBRARIES)
	target_link_libraries(bcunit INTERFACE ${CURSES_LIBRARIES})
endif()
target_compile_definitions(bcunit INTERFACE "$<BUILD_INTERFACE:BCUNIT_USE_BUILD_INTERFACE>")


install(TARGETS bcunit EXPORT ${PROJECT_NAME}Targets
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

if(MSVC AND BUILD_SHARED_LIBS)
	install(FILES $<TARGET_PDB_FILE:bcunit>
		DESTINATION ${CMAKE_INSTALL_BINDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
		CONFIGURATIONS Debug RelWithDebInfo
	)
endif()


if(ENABLE_BCUNIT_TEST)
	add_library(bcunit_test STATIC ${FRAMEWORK_SOURCE_FILES})
	target_compile_definitions(bcunit_test PUBLIC MEMTRACE BCUNIT_BUILD_TESTS BCUNIT_DO_NOT_DEFINE_UNLESS_BUILDING_TESTS)
	target_include_directories(bcunit_test PUBLIC Test)

	add_subdirectory(Test)
endif()

=== Examples/AutomatedTest/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

add_executable(AutomatedTest AutomatedTest.c)
target_link_libraries(AutomatedTest bcunit bcunitexamples)

install(TARGETS AutomatedTest DESTINATION share/BCUnit/Examples/Automated)
install(FILES README DESTINATION share/BCUnit/Examples/Automated)

=== Examples/BasicTest/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

add_executable(BasicTest BasicTest.c)
target_link_libraries(BasicTest bcunit bcunitexamples)

install(TARGETS BasicTest DESTINATION share/BCUnit/Examples/Basic)
install(FILES README DESTINATION share/BCUnit/Examples/Basic)

=== Examples/ConsoleTest/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

add_executable(ConsoleTest ConsoleTest.c)
target_link_libraries(ConsoleTest bcunit bcunitexamples)

install(TARGETS ConsoleTest DESTINATION share/BCUnit/Examples/Console)
install(FILES README DESTINATION share/BCUnit/Examples/Console)

=== PKGBUILD ===
# Maintainer: Andrew Sun <adsun701@gmail.com>

_realname=bcunit
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.3.101
pkgrel=1
pkgdesc="Lightweight system for writing, administering, and running unit tests in C (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/BelledonneCommunications/bcunit"
license=('spdx:LGPL-2.0-or-later')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-autotools"
             'autogen')
source=("https://github.com/BelledonneCommunications/bcunit/archive/${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('a89ce3b6034db96e392b6572d4a9d29f7fe7824580b8f28acf2b3da4418f1ac7')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"
  [ -x configure ] || ./autogen.sh
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  ../${_realname}-${pkgver}/configure \
    --prefix=${MINGW_PREFIX} \
    --build=${MINGW_CHOST} \
    --host=${MINGW_CHOST} \
    --target=${MINGW_CHOST} \
    --enable-static \
    --enable-shared

  make
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}
  make install DESTDIR="${pkgdir}"
  mv "${pkgdir}${MINGW_PREFIX}"/doc "${pkgdir}${MINGW_PREFIX}"/share/doc
}
